/*
 * V1_1.c
 *
 * Created: 26.3.2012 17:40:58
 *  Author: Martin
 */ 

#include <avr/io.h>
#include <inttypes.h>
#include <avr/io.h>
#include <avr/pgmspace.h>
#define F_CPU 16000000UL	// frekvence hodinovho signlu (nutn pro delay.h)
#include <util/delay.h>     // hlavikov soubor pro zpodn
#include <avr/interrupt.h>
#include <avr/eeprom.h> 

#include "ks0108.h"
#include "arial_bold_14.h"
#include "SC.h"
#include "Bitmap.h"
#include "TM.h"

volatile char vysledek[];
volatile char vysledek2[];
volatile unsigned long int remain_x, all_x,remain_y, all_y,all_x_lcd,all_y_lcd;
unsigned char TXT[]="VUT";
volatile uint8_t equal;
volatile uint8_t right_touch;
volatile uint8_t adrr_read;

int main(void)
{
equal = 0; 	
ADMUX =		0b00100000; 
SFIOR =		0b00000000;
sei();

 ks0108Init(0);
 ks0108SelectFont(Arial_Bold_14, ks0108ReadFontData, BLACK);
 first_start = 1;
 axis = 1; 
 y_d = 1;
 x_d = 1;
 touch = 0;
 int i,j;
 

 adrr_read = 0;
 yAD_min=eeprom_read_byte((uint8_t *)adrr_read); 
 _delay_ms(1); 
 adrr_read = 1;
 yAD_max=eeprom_read_byte((uint8_t *)adrr_read); 
 _delay_ms(1); 
 adrr_read = 2;
 xAD_min=eeprom_read_byte((uint8_t *)adrr_read); 
 _delay_ms(1); 
 adrr_read = 3;
 xAD_max=eeprom_read_byte((uint8_t *)adrr_read); 
  

 right_calibration = 1;
 
 
 while(1)
    {
	   if(first_start == 1)
	   {
		 first_start = 0;   
		 ks0108ClearScreen();
	     right_run1(mmia_logo);
	     _delay_ms(500);
		 ks0108ClearScreen();	
	     right_run2(mmia_logo);
	     _delay_ms(500);		 
		 ks0108ClearScreen();	
		 show_icon(switch_on2,0, 0,32);
		 show_icon(connect_32,1, 0,32);
		 show_icon(calibrate_32,2, 0,32);	
 	     show_icon(test_32,3, 0,32);
		 show_icon(setting_32,0, 1,32); 
		 show_icon(numpad_32,1, 1,32); 
		 show_icon(switch_on1_16,4, 1,16); 
		 show_icon(switch_on1_16,5, 1,16); 
		 show_icon(exit_32,3, 1,32);
	   }
	   
	   
	  right_touch =  touch_scan();
	
	 
      if (right_touch == 1)
      {
		  
	   axis_AD_y();	   
       axis_AD_x();


  	  if((*x <= 128) && (*x >= 96) && (*y < 30))
	   { 		  
 	    ks0108ClearScreen();
 	    show_icon(switch_on2,0, 0,32);
		show_icon(connect_32,1, 0,32);
		show_icon(calibrate_32,2, 0,32);	
 	    show_icon_invert(test_32,3, 0,32);
		show_icon(setting_32,0, 1,32); 
		show_icon(numpad_32,1, 1,32); 
		show_icon(switch_on1_16,4, 1,16); 
		show_icon(switch_on1_16,5, 1,16); 
		show_icon(exit_32,3, 1,32); 
		_delay_ms(1000);	
		screen_saver((unsigned char*)TXT);	
		_delay_ms(2000);
 	   }
		
	 if((*x <= 95) && (*x >= 65) && (*y < 30))
	  {  
 	   ks0108ClearScreen();
        show_icon(switch_on2,0, 0,32);
		show_icon(connect_32,1, 0,32);
		show_icon_invert(calibrate_32,2, 0,32);	
 	    show_icon(test_32,3, 0,32);
		show_icon(setting_32,0, 1,32); 
		show_icon(numpad_32,1, 1,32); 
		show_icon(switch_on1_16,4, 1,16); 
		show_icon(switch_on1_16,5, 1,16); 
		show_icon(exit_32,3, 1,32); 
		_delay_ms(1000);
		calibrate();
 	  }
	   
	 if((*x <= 64) && (*x >= 32) && (*y < 30))
	  { 
 	   ks0108ClearScreen();
        show_icon(switch_on2,0, 0,32);
		show_icon_invert(connect_32,1, 0,32);
		show_icon(calibrate_32,2, 0,32);	
 	    show_icon(test_32,3, 0,32);
		show_icon(setting_32,0, 1,32); 
		show_icon(numpad_32,1, 1,32);
		show_icon(switch_on1_16,4, 1,16); 
		show_icon(switch_on1_16,5, 1,16);  
		show_icon(exit_32,3, 1,32);
		_delay_ms(1000);
 	  }
 	  

 	   if((*x <= 32) && (*x >= 0) && (*y < 30))
 	   {	  
	   ks0108ClearScreen();
        show_icon(switch_off2,0, 0,32);
		show_icon(connect_32,1, 0,32);
		show_icon(calibrate_32,2, 0,32);	
 	    show_icon(test_32,3, 0,32);
		show_icon(setting_32,0, 1,32); 
		show_icon(numpad_32,1, 1,32); 
		show_icon(switch_on1_16,4, 1,16); 
		show_icon(switch_on1_16,5, 1,16); 
		show_icon(exit_32,3, 1,32);
		_delay_ms(1000);
	  }
	  
	  //second line
	  
	   if((*x <= 128) && (*x >= 96) && (*y > 35))
	   { 		  
 	    ks0108ClearScreen();
 	    show_icon(switch_on2,0, 0,32);
		show_icon(connect_32,1, 0,32);
		show_icon(calibrate_32,2, 0,32);	
 	    show_icon(test_32,3, 0,32);
		show_icon(setting_32,0, 1,32); 
		show_icon(numpad_32,1, 1,32); 
		show_icon(switch_on1_16,4, 1,16); 
		show_icon(switch_on1_16,5, 1,16); 
		show_icon_invert(exit_32,3, 1,32); 
		_delay_ms(1000);		
 	   }
		
	 if((*x <= 95) && (*x >= 81) && (*y > 35))
	  {  
 	   ks0108ClearScreen();
        show_icon(switch_on2,0, 0,32);
		show_icon(connect_32,1, 0,32);
		show_icon(calibrate_32,2, 0,32);	
 	    show_icon(test_32,3, 0,32);
		show_icon(setting_32,0, 1,32); 
		show_icon(numpad_32,1, 1,32); 
		show_icon(switch_on1_16,4, 1,16); 
		show_icon(switch_off1_16,5, 1,16); 
		show_icon(exit_32,3, 1,32); 
		_delay_ms(1000);
		show_icon(switch_on1_16,5, 1,16);
 	  }
	   
	   if((*x <= 80) && (*x >= 65) && (*y > 35))
	  {  
 	   ks0108ClearScreen();
        show_icon(switch_on2,0, 0,32);
		show_icon(connect_32,1, 0,32);
		show_icon(calibrate_32,2, 0,32);	
 	    show_icon(test_32,3, 0,32);
		show_icon(setting_32,0, 1,32); 
		show_icon(numpad_32,1, 1,32); 
		show_icon(switch_off1_16,4, 1,16); 
		show_icon(switch_on1_16,5, 1,16); 
		show_icon(exit_32,3, 1,32); 
		_delay_ms(1000);
		show_icon(switch_on1_16,4, 1,16); 
 	  }
	   
	   
	 if((*x <= 64) && (*x >= 32) && (*y > 35))
	  { 
 	   ks0108ClearScreen();
        show_icon(switch_on2,0, 0,32);
		show_icon(connect_32,1, 0,32);
		show_icon(calibrate_32,2, 0,32);	
 	    show_icon(test_32,3, 0,32);
		show_icon(setting_32,0, 1,32); 
		show_icon_invert(numpad_32,1, 1,32); 
		show_icon(switch_on1_16,4, 1,16); 
		show_icon(switch_on1_16,5, 1,16); 
		show_icon(exit_32,3, 1,32);
		_delay_ms(1000);
		
		show_numpad(numeric_board,654321);
 	  }
 	  

 	   if((*x <= 32) && (*x >= 0) && (*y > 35))
 	   {	  
	   ks0108ClearScreen();
        show_icon(switch_on2,0, 0,32);
		show_icon(connect_32,1, 0,32);
		show_icon(calibrate_32,2, 0,32);	
 	    show_icon(test_32,3, 0,32);
		show_icon_invert(setting_32,0, 1,32); 
		show_icon(numpad_32,1, 1,32); 
		show_icon(switch_on1_16,4, 1,16); 
		show_icon(switch_on1_16,5, 1,16); 
		show_icon(exit_32,3, 1,32);
		_delay_ms(1000);
	  }
	  
		right_touch = 0;
	   show_icon(switch_on2,0, 0,32);
	   show_icon(connect_32,1, 0,32);
 	   show_icon(calibrate_32,2, 0,32);	
  	   show_icon(test_32,3, 0,32);
	   show_icon(setting_32,0, 1,32); 
	   show_icon(numpad_32,1, 1,32); 
	   show_icon(switch_on1_16,4, 1,16); 
	   show_icon(switch_on1_16,5, 1,16); 
	   show_icon(exit_32,3, 1,32); 
     }
    }  
}

ISR(ADC_vect)
{ 
  if (right_calibration == 0)
  {
  if (axis == 0) 
   {	 
	 numberx = ADCH;
	 x = & numberx; 
   }
 
   if (axis == 1)
   {
 	 numbery = ADCH;
	 y = & numbery;
	 
   } 
  }
  
  if (right_calibration == 1)
  {
   if (axis == 0)
   {	 
	 numberx = ADCH;
	 all_x = (xAD_max*100) - (xAD_min*100);
	 all_x_lcd = all_x /128;
	 
	 
	 numberx = (((numberx*100)-(xAD_min*100))/all_x_lcd);

	 x = & numberx;	 
   }
 
   if (axis == 1)
   {
 	 numbery = ADCH;
	 all_y = (yAD_max*100) - (yAD_min*100);
	 all_y_lcd = all_y /64;
	 
	 numbery = (((numbery*100)-(yAD_min*100))/all_y_lcd);
	 y = & numbery;
   } 
  }
}

